attribute @s minecraft:generic.attack_damage base set 0
attribute @s minecraft:generic.attack_speed base set 4
gamemode adventure

# Remove Vanilla Systems
effect give @s minecraft:resistance infinite 255 true
effect give @s minecraft:saturation infinite 255 true
xp set @s 0 points
xp set @s 0 levels

# Give coins
execute store result score @s bungeon.temp run clear @s gold_nugget
scoreboard players operation @s bungeon.coins += @s bungeon.temp

# Drop Items
execute unless data entity @s SelectedItem at @n[type=item, distance=..2, nbt={Age:0s}] run function bungeon:player/item/drop/init with storage bungeon:data
kill @n[type=item, distance=..2, nbt={Age:0s}, nbt=!{Item:{id:"minecraft:gold_nugget"}}]


# Held Item
scoreboard players set @s bungeon.temp -1
execute unless score @s bungeon.sneak = @s bungeon.last_sneak run scoreboard players operation @s bungeon.map *= @s[scores={bungeon.sneak_held=0}] bungeon.temp
execute unless score @s bungeon.sneak = @s bungeon.last_sneak run scoreboard players set @s bungeon.sneak_held 1
execute if score @s bungeon.sneak = @s bungeon.last_sneak run scoreboard players set @s bungeon.sneak_held 0
scoreboard players operation @s bungeon.last_sneak = @s bungeon.sneak
execute as @s[gamemode=!creative, scores={bungeon.map=-1}] run function bungeon:player/item/held/tick with storage bungeon:data
execute as @s[gamemode=!creative, scores={bungeon.map=1}] run function bungeon:player/item/held/map

# Update Gui
$function bungeon:player/stat/health/display with storage bungeon:data players.$(name).gui
$function bungeon:player/stat/display/stats with storage bungeon:data players.$(name).stats
function bungeon:player/stat/display/upgrade/format with storage bungeon:data

scoreboard players set @s bungeon.temp 100
$execute store result score #math bungeon.temp run data get storage bungeon:data players.$(name).stats.speed
execute store result storage bungeon:data temp float 0.00001 run scoreboard players operation @s bungeon.temp *= #math bungeon.temp
function bungeon:player/stat/update_speed with storage bungeon:data

function bungeon:player/stat/health/update with storage bungeon:data

scoreboard players remove @s bungeon.cooldown 1
scoreboard players remove @s bungeon.iframe 1
scoreboard players remove @s[scores={bungeon.blocking=1..}] bungeon.blocking 1
scoreboard players add @s[scores={bungeon.blocking=..-1}] bungeon.blocking 1

item replace entity @s player.cursor with air

execute as @s[predicate=bungeon:in_void] run function bungeon:player/exit/check